﻿Namespace Library

    Public Class LendingBooks

        Public Enum SearchField
            نمایش_همه = 0
            کد_عضویت = 1
            نام_عضو = 2
            نام_خانوادگی = 3
            کد_کتاب = 4
            نام_کتاب = 5
            تاریخ_امانت_دادن_کتاب = 6
            موعد_برگرداندن_کتاب = 7
        End Enum

        Public Enum SortField
            بدون_مرتب_سازی = 0
            کد_عضویت = 1
            نام_عضو = 2
            نام_خانوادگی = 3
            کد_کتاب = 4
            نام_کتاب = 5
            تاریخ_امانت_دادن_کتاب = 6
            موعد_برگرداندن_کتاب = 7
        End Enum

        Public Function INSERT(ByVal Book_ID_ As Int64, _
                               ByVal Member_ID_ As Int64, _
                               ByVal LendDate_ As String, _
                               ByVal DueDate_ As String, _
                               ByVal ReturnDate_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_LendingBooks_INSERT"
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)
                cmd.Parameters.AddWithValue("@LendDate", LendDate_)
                cmd.Parameters.AddWithValue("@DueDate", DueDate_)
                cmd.Parameters.AddWithValue("@ReturnDate", ReturnDate_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function UPDATE(ByVal LendingBook_ID_ As Int64, _
                               ByVal Book_ID_ As Int64, _
                               ByVal Member_ID_ As Int64, _
                               ByVal LendDate_ As String, _
                               ByVal DueDate_ As String, _
                               ByVal ReturnDate_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_LendingBooks_UPDATE"
                cmd.Parameters.AddWithValue("@LendingBook_ID", LendingBook_ID_)
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)
                cmd.Parameters.AddWithValue("@LendDate", LendDate_)
                cmd.Parameters.AddWithValue("@DueDate", DueDate_)
                cmd.Parameters.AddWithValue("@ReturnDate", ReturnDate_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function DELETE(ByVal LendingBook_ID_ As Int64) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_LendingBooks_DELETE"
                cmd.Parameters.AddWithValue("@LendingBook_ID", LendingBook_ID_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function SELECT_ByID(ByVal LendingBook_ID_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_LendingBooks_SELECT_ByID"
                cmd.Parameters.AddWithValue("@LendingBook_ID", LendingBook_ID_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

        Public Function SELECT_ALL(ByVal SearchField_ As SearchField, _
                                   ByVal SearchValue_ As String, _
                                   ByVal SearchValue2_ As String, _
                                   ByVal SortField_ As SortField, _
                                   ByVal ASC_OR_DESC_ As Integer) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.Text

                Dim query As String = ""
                query &= "Select LB.LendingBook_ID " & vbCrLf
                query &= ", LB.Book_ID " & vbCrLf
                query &= ", LB.Member_ID " & vbCrLf
                query &= ", LB.LendDate " & vbCrLf
                query &= ", LB.DueDate " & vbCrLf
                query &= ", LB.ReturnDate " & vbCrLf
                query &= ", LB.RowDesc " & vbCrLf
                query &= ", B.BookCode " & vbCrLf
                query &= ", B.Title " & vbCrLf
                query &= ", M.MembershipCode " & vbCrLf
                query &= ", M.FirstName " & vbCrLf
                query &= ", M.LastName " & vbCrLf
                query &= "FROM LendingBooks LB " & vbCrLf
                query &= "LEFT JOIN Books B ON LB.Book_ID = B.Book_ID " & vbCrLf
                query &= "LEFT JOIN Members M ON LB.Member_ID = M.Member_ID " & vbCrLf
                query &= " " & vbCrLf
                query &= "WHERE (1=1)" & vbCrLf
                Select Case SearchField_
                    Case SearchField.نمایش_همه
                        '...
                    Case SearchField.کد_عضویت
                        query &= "AND (M.MembershipCode = @SearchValue) " & vbCrLf
                    Case SearchField.نام_عضو
                        query &= "AND (M.FirstName LIKE N'%' + @SearchValue + '%') " & vbCrLf
                    Case SearchField.نام_خانوادگی
                        query &= "AND (M.LastName LIKE N'%' + @SearchValue + '%') " & vbCrLf
                    Case SearchField.کد_کتاب
                        query &= "AND (B.BookCode = @SearchValue) " & vbCrLf
                    Case SearchField.نام_کتاب
                        query &= "AND (B.Title LIKE N'%' + @SearchValue + '%') " & vbCrLf
                    Case SearchField.تاریخ_امانت_دادن_کتاب
                        query &= "AND (LB.LendDate BETWEEN @SearchValue AND @SearchValue2) " & vbCrLf
                    Case SearchField.موعد_برگرداندن_کتاب
                        query &= "AND (LB.DueDate BETWEEN @SearchValue AND @SearchValue2) " & vbCrLf
                End Select
                Dim str_ASC_OR_DESC_ As String = ""
                If ASC_OR_DESC_ = 0 Then
                    str_ASC_OR_DESC_ = "ASC"
                Else
                    str_ASC_OR_DESC_ = "DESC"
                End If
                Select Case SortField_
                    Case SortField.بدون_مرتب_سازی
                        '...
                    Case SearchField.کد_عضویت
                        query &= "ORDER BY MembershipCode " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.نام_عضو
                        query &= "ORDER BY FirstName " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.نام_خانوادگی
                        query &= "ORDER BY LastName " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.کد_کتاب
                        query &= "ORDER BY BookCode " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.نام_کتاب
                        query &= "ORDER BY Title " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.تاریخ_امانت_دادن_کتاب
                        query &= "ORDER BY LendDate " & str_ASC_OR_DESC_ & vbCrLf
                    Case SearchField.موعد_برگرداندن_کتاب
                        query &= "ORDER BY DueDate " & str_ASC_OR_DESC_ & vbCrLf
                End Select
                query &= "" & vbCrLf

                cmd.CommandText = query
                cmd.Parameters.AddWithValue("@SearchValue", SearchValue_)
                cmd.Parameters.AddWithValue("@SearchValue2", SearchValue2_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

    End Class

End Namespace






