﻿Namespace Library

    Public Class Members

        Public Enum SearchField
            نمایش_همه = 0
            کد_عضویت = 1
            نام = 2
            نام_خانوادگی = 3
        End Enum

        Public Enum SortField
            بدون_مرتب_سازی = 0
            کد_عضویت = 1
            نام = 2
            نام_خانوادگی = 3
        End Enum

        Public Function INSERT(ByVal MembershipCode_ As Int64, _
                               ByVal FirstName_ As String, _
                               ByVal LastName_ As String, _
                               ByVal NationalCode_ As String, _
                               ByVal PhoneNumbers_ As String, _
                               ByVal MobileNumber_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_INSERT"
                cmd.Parameters.AddWithValue("@MembershipCode", MembershipCode_)
                cmd.Parameters.AddWithValue("@FirstName", FirstName_)
                cmd.Parameters.AddWithValue("@LastName", LastName_)
                cmd.Parameters.AddWithValue("@NationalCode", NationalCode_)
                cmd.Parameters.AddWithValue("@PhoneNumbers", PhoneNumbers_)
                cmd.Parameters.AddWithValue("@MobileNumber", MobileNumber_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function UPDATE(ByVal Member_ID_ As Int64, _
                               ByVal MembershipCode_ As Int64, _
                               ByVal FirstName_ As String, _
                               ByVal LastName_ As String, _
                               ByVal NationalCode_ As String, _
                               ByVal PhoneNumbers_ As String, _
                               ByVal MobileNumber_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_UPDATE"
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)
                cmd.Parameters.AddWithValue("@MembershipCode", MembershipCode_)
                cmd.Parameters.AddWithValue("@FirstName", FirstName_)
                cmd.Parameters.AddWithValue("@LastName", LastName_)
                cmd.Parameters.AddWithValue("@NationalCode", NationalCode_)
                cmd.Parameters.AddWithValue("@PhoneNumbers", PhoneNumbers_)
                cmd.Parameters.AddWithValue("@MobileNumber", MobileNumber_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function DELETE(ByVal Member_ID_ As Int64) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_DELETE"
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function SELECT_ByID(ByVal Member_ID_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_SELECT_ByID"
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

        Public Function SELECT_ByID_For_Print(ByVal Member_ID_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_SELECT_ByID_For_Print"
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

        Public Function IsExist_MembershipCode(ByVal MembershipCode_ As Int64, _
                                               ByVal Member_ID_ As Int64) As Boolean

            Dim IsExist As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Members_SELECT_COUNT_ByMembershipCode"
                cmd.Parameters.AddWithValue("@MembershipCode", MembershipCode_)
                cmd.Parameters.AddWithValue("@Member_ID", Member_ID_)

                Dim countExist As Integer = CInt(cmd.ExecuteScalar())
                If countExist > 0 Then
                    IsExist = True
                End If

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsExist
        End Function

        Public Function SELECT_ALL(ByVal SearchField_ As SearchField, _
                                   ByVal SearchValue_ As String, _
                                   ByVal SortField_ As SortField, _
                                   ByVal ASC_OR_DESC_ As Integer) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.Text

                Dim query As String = ""
                query &= "Select M.Member_ID" & vbCrLf
                query &= ",M.MembershipCode" & vbCrLf
                query &= ",M.FirstName" & vbCrLf
                query &= ",M.LastName" & vbCrLf
                query &= ",M.NationalCode" & vbCrLf
                query &= ",M.PhoneNumbers" & vbCrLf
                query &= ",M.MobileNumber" & vbCrLf
                query &= ",M.RowDesc" & vbCrLf
                query &= "FROM Members AS M" & vbCrLf
                query &= "WHERE (1=1)" & vbCrLf
                Select Case SearchField_
                    Case SearchField.نمایش_همه
                        '...
                    Case SearchField.کد_عضویت
                        query &= "AND (M.MembershipCode = @SearchValue) " & vbCrLf
                    Case SearchField.نام
                        query &= "AND (M.FirstName LIKE N'%' + @SearchValue + '%') " & vbCrLf
                    Case SearchField.نام_خانوادگی
                        query &= "AND (M.LastName LIKE N'%' + @SearchValue + '%') " & vbCrLf
                End Select
                Dim str_ASC_OR_DESC_ As String = ""
                If ASC_OR_DESC_ = 0 Then
                    str_ASC_OR_DESC_ = "ASC"
                Else
                    str_ASC_OR_DESC_ = "DESC"
                End If
                Select Case SortField_
                    Case SortField.بدون_مرتب_سازی
                        '...
                    Case SortField.کد_عضویت
                        query &= "ORDER BY MembershipCode " & str_ASC_OR_DESC_ & vbCrLf
                    Case SortField.نام
                        query &= "ORDER BY FirstName " & str_ASC_OR_DESC_ & vbCrLf
                    Case SortField.نام_خانوادگی
                        query &= "ORDER BY LastName " & str_ASC_OR_DESC_ & vbCrLf
                End Select
                query &= "" & vbCrLf

                cmd.CommandText = query
                cmd.Parameters.AddWithValue("@SearchValue", SearchValue_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

    End Class

End Namespace






