﻿Public Class FrmNewBookCategorty

#Region "Variables"
    Public BookCategorty_ID_ As Int64 = -1
    Public CalledForm_ As FrmTreeBookCategorty = Nothing
    Public FormMode_ As Library_Shared.Enums.FormMode = Library_Shared.Enums.FormMode.None
    Public BookCategorty_ID_Parent_ As Int64 = -1
#End Region

#Region "Controls And Forms Events"

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Me.SaveData()
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub FrmNewMember_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                Me.Text = "افزودن دسته بندی جدید"
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                Me.Text = "ویرایش دسته بندی"
                Me.ShowRecordInfo()
            Case Library_Shared.Enums.FormMode.حالت_نمایش
                Me.Text = "نمایش دسته بندی"
                Me.ShowRecordInfo()
                btnSave.Enabled = False
                txtCategoryName.ReadOnly = True
        End Select
    End Sub

#End Region

#Region "My Rutins"

    Private Sub SaveData()
        If Validation() = False Then Exit Sub
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                If Me.Insert_ = True Then
                    MsgBox("رکورد با موفقیت اضافه شد", MsgBoxStyle.Information, "پیغام")
                    Me.ClearForm()
                    Me.CalledForm_.FillTreeView()
                End If
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                If Me.Update_ = True Then
                    MsgBox("رکورد با موفقیت ویرایش شد", MsgBoxStyle.Information, "پیغام")
                    Me.Close()
                    Me.CalledForm_.FillTreeView()
                End If
        End Select
    End Sub

    Private Function Insert_() As Boolean
        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        Dim IsComplete As Boolean = obj_BookCategorty.INSERT(Me.BookCategorty_ID_Parent_, txtCategoryName.Text)
        Return IsComplete
    End Function

    Private Function Update_() As Boolean
        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        Dim IsComplete As Boolean = obj_BookCategorty.UPDATE(Me.BookCategorty_ID_, txtCategoryName.Text)
        Return IsComplete
    End Function

    Private Sub ShowRecordInfo()
        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        Dim dt As DataTable = obj_BookCategorty.SELECT_ByID(Me.BookCategorty_ID_)
        If dt.Rows.Count > 0 Then
            txtCategoryName.Text = dt.Rows(0).Item("CategoryName").ToString
            Me.BookCategorty_ID_Parent_ = Library_Shared.Functions.GetNumericValue(dt.Rows(0).Item("BookCategorty_ID_Parent"), -1)
        End If
    End Sub

    Private Function Validation() As Boolean
        '---------------------
        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        '---------------------
        'PreValidation
        txtCategoryName.Text = txtCategoryName.Text.Trim
        '---------------------
        If txtCategoryName.Text.Length = 0 Then
            MsgBox("نام دسته بندی را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtCategoryName.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If obj_BookCategorty.IsExist_CategoryName(txtCategoryName.Text, Me.BookCategorty_ID_Parent_, Me.BookCategorty_ID_) = True Then
            MsgBox("نام دسته بندی تکراری می باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtCategoryName.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        Return True
    End Function

    Private Sub ClearForm()
        txtCategoryName.Text = ""
    End Sub

#End Region




End Class