﻿Public Class FrmNewBooks

#Region "Variables"
    Public Book_ID_ As Int64 = -1
    Public CalledForm_ As FrmSelectBooks = Nothing
    Public FormMode_ As Library_Shared.Enums.FormMode = Library_Shared.Enums.FormMode.None
    Private BookCategorty_ID_ As Int64 = -1
#End Region

#Region "Controls And Forms Events"

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Me.SaveData()
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub FrmNewMember_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                Me.Text = "افزودن کتاب جدید"
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                Me.Text = "ویرایش کتاب"
                Me.ShowRecordInfo()
            Case Library_Shared.Enums.FormMode.حالت_نمایش
                Me.Text = "نمایش کتاب"
                Me.ShowRecordInfo()
                btnSave.Enabled = False
                txtBookCode.ReadOnly = True
                txtTitle.ReadOnly = True
                txtPublisher.ReadOnly = True
                txtPublishYear.ReadOnly = True
                txtRowDesc.ReadOnly = True
                btnSelectBookCategorty.Enabled = False
                btnClearBookCategorty.Enabled = False
        End Select
    End Sub

    Private Sub btnSelectBookCategorty_Click(sender As Object, e As EventArgs) Handles btnSelectBookCategorty.Click
        Dim FrmNew_ As New FrmTreeBookCategorty
        With FrmNew_
            .ShowDialog()
            If .IsSelected = True Then
                Me.BookCategorty_ID_ = .ReturnID
                Me.txtCategoryName.Text = .ReturnName
            End If
        End With
    End Sub

    Private Sub btnClearBookCategorty_Click(sender As Object, e As EventArgs) Handles btnClearBookCategorty.Click
        Me.BookCategorty_ID_ = -1
        Me.txtCategoryName.Text = ""
    End Sub

#End Region

#Region "My Rutins"

    Private Sub SaveData()
        If Validation() = False Then Exit Sub
        Select Case Me.FormMode_
            Case Library_Shared.Enums.FormMode.حالت_افزودن
                If Me.Insert_ = True Then
                    MsgBox("رکورد با موفقیت اضافه شد", MsgBoxStyle.Information, "پیغام")
                    Me.ClearForm()
                    Me.CalledForm_.FillGrid()
                End If
            Case Library_Shared.Enums.FormMode.حالت_ویرایش
                If Me.Update_ = True Then
                    MsgBox("رکورد با موفقیت ویرایش شد", MsgBoxStyle.Information, "پیغام")
                    Me.Close()
                    Me.CalledForm_.FillGrid()
                End If
        End Select
    End Sub

    Private Function Insert_() As Boolean
        Dim obj_Books As New Library_Database.Library.Books
        Dim IsComplete As Boolean = obj_Books.INSERT(txtBookCode.Text, txtTitle.Text, txtPublisher.Text, txtPublishYear.Text, txtRowDesc.Text, Me.BookCategorty_ID_)
        Return IsComplete
    End Function

    Private Function Update_() As Boolean
        Dim obj_Books As New Library_Database.Library.Books
        Dim IsComplete As Boolean = obj_Books.UPDATE(Me.Book_ID_, txtBookCode.Text, txtTitle.Text, txtPublisher.Text, txtPublishYear.Text, txtRowDesc.Text, Me.BookCategorty_ID_)
        Return IsComplete
    End Function

    Private Sub ShowRecordInfo()
        Dim obj_Books As New Library_Database.Library.Books
        Dim dt As DataTable = obj_Books.SELECT_ByID(Me.Book_ID_)
        If dt.Rows.Count > 0 Then
            txtTitle.Text = dt.Rows(0).Item("Title").ToString
            txtPublisher.Text = dt.Rows(0).Item("Publisher").ToString
            txtBookCode.Text = dt.Rows(0).Item("BookCode").ToString
            txtPublishYear.Text = dt.Rows(0).Item("PublishYear").ToString
            txtRowDesc.Text = dt.Rows(0).Item("RowDesc").ToString
            txtCategoryName.Text = dt.Rows(0).Item("CategoryName").ToString
            Me.BookCategorty_ID_ = Library_Shared.Functions.GetNumericValue(dt.Rows(0).Item("BookCategorty_ID"), -1)
        End If
    End Sub

    Private Function Validation() As Boolean
        '---------------------
        Dim obj_Books As New Library_Database.Library.Books
        '---------------------
        'PreValidation
        txtBookCode.Text = txtBookCode.Text.Trim
        txtTitle.Text = txtTitle.Text.Trim
        txtPublisher.Text = txtPublisher.Text.Trim
        txtPublishYear.Text = txtPublishYear.Text.Trim
        '---------------------
        If txtBookCode.Text.Length = 0 Then
            MsgBox("کد کتاب را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtBookCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If IsNumeric(txtBookCode.Text) = False Then
            MsgBox("کد کتاب صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtBookCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If CLng(txtBookCode.Text) <= 0 Then
            MsgBox("کد کتاب نمی تواند صفر یا عددی منفی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtBookCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtTitle.Text.Length = 0 Then
            MsgBox("نام کتاب را وارد کنید", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtTitle.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        If txtPublishYear.Text.Length > 0 Then
            '--------------
            If txtPublishYear.Text.Length <> 4 Then
                MsgBox("سال نشر صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
                txtPublishYear.Focus()
                Return False
                Exit Function
            End If
            '--------------
            If IsNumeric(txtPublishYear.Text) = False Then
                MsgBox("سال نشر صحیح نمی باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
                txtPublishYear.Focus()
                Return False
                Exit Function
            End If
            '--------------
        End If
        '---------------------
        If obj_Books.IsExist_BookCode(txtBookCode.Text, Me.Book_ID_) = True Then
            MsgBox("کد کتاب تکراری می باشد", MsgBoxStyle.Critical, "خطا در اعتبار سنحی داده ها")
            txtBookCode.Focus()
            Return False
            Exit Function
        End If
        '---------------------
        Return True
    End Function

    Private Sub ClearForm()
        txtTitle.Text = ""
        txtPublisher.Text = ""
        txtBookCode.Text = ""
        txtPublishYear.Text = ""
        txtRowDesc.Text = ""
        Me.BookCategorty_ID_ = -1
        txtCategoryName.Text = ""
    End Sub

#End Region





End Class