﻿Public Class FrmTreeBookCategorty

#Region "Variables"

#End Region

#Region "Properties"

    Private IsSelectedValue As Boolean = False
    Public Property IsSelected() As Boolean
        Get
            Return IsSelectedValue
        End Get
        Set(ByVal value As Boolean)
            IsSelectedValue = value
        End Set
    End Property

    Private ReturnIDValue As Int64 = -1
    Public Property ReturnID() As Int64
        Get
            Return ReturnIDValue
        End Get
        Set(ByVal value As Int64)
            ReturnIDValue = value
        End Set
    End Property

    Private ReturnNameValue As String = ""
    Public Property ReturnName() As String
        Get
            Return ReturnNameValue
        End Get
        Set(ByVal value As String)
            ReturnNameValue = value
        End Set
    End Property

#End Region

#Region "Controls And Forms Events"

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        FillTreeView()
    End Sub

    Private Sub FrmSelectMembers_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Private Sub btnAdd_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        If TreeView1.SelectedNode Is Nothing Then
            MsgBox("دسته بندی پدر انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewBookCategorty
        Frm_.CalledForm_ = Me
        Frm_.BookCategorty_ID_Parent_ = CLng(TreeView1.SelectedNode.Name)
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_افزودن
        Frm_.ShowDialog()
    End Sub

    Private Sub btnEdit_Click(sender As Object, e As EventArgs) Handles btnEdit.Click
        If TreeView1.SelectedNode Is Nothing Then
            MsgBox("رکوردی جهت ویرایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If TreeView1.SelectedNode.Name = -1 Then
            MsgBox("امکان ویرایش نود ریشه وجود ندارد", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewBookCategorty
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_ویرایش
        Frm_.BookCategorty_ID_ = CLng(TreeView1.SelectedNode.Name)
        Frm_.ShowDialog()
    End Sub

    Private Sub btnView_Click(sender As Object, e As EventArgs) Handles btnView.Click
        If TreeView1.SelectedNode Is Nothing Then
            MsgBox("رکوردی جهت نمایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If TreeView1.SelectedNode.Name = -1 Then
            MsgBox("امکان نمایش نود ریشه وجود ندارد", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewBookCategorty
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_نمایش
        Frm_.BookCategorty_ID_ = CLng(TreeView1.SelectedNode.Name)
        Frm_.ShowDialog()
    End Sub

    Private Sub btnDelete_Click(sender As Object, e As EventArgs) Handles btnDelete.Click
        If TreeView1.SelectedNode Is Nothing Then
            MsgBox("رکوردی جهت حذف انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If TreeView1.SelectedNode.Name = -1 Then
            MsgBox("امکان حذف نود ریشه وجود ندارد", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If MsgBox("آیا از حذف رکورد انتخاب شده مطمئن هستید", MsgBoxStyle.Question + MsgBoxStyle.YesNo, "تایید حذف") = MsgBoxResult.No Then Exit Sub

        Dim obj_Books As New Library_Database.Library.BookCategorty
        Dim IsComplete As Boolean = obj_Books.DELETE(CLng(TreeView1.SelectedNode.Name))

        If IsComplete = True Then
            MsgBox("رکورد با موفقیت حذف شد", MsgBoxStyle.Information, "پیغام")
            Me.FillTreeView()
        End If
    End Sub

    Private Sub btnSelect_Click(sender As Object, e As EventArgs) Handles btnSelect.Click
        If TreeView1.SelectedNode Is Nothing Then
            MsgBox("رکوردی انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If TreeView1.SelectedNode.Name = -1 Then
            MsgBox("امکان انتخاب نود ریشه وجود ندارد", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Me.ReturnIDValue = CLng(TreeView1.SelectedNode.Name)
        Me.ReturnNameValue = TreeView1.SelectedNode.Text
        Me.IsSelected = True
        Me.Close()
    End Sub

#End Region

#Region "My Rutins"

    Public Sub FillTreeView()
        TreeView1.Nodes.Clear()
        Dim rootNode As New TreeNode
        With rootNode
            .Name = -1
            .Text = "دسته بندی کتابها"
        End With

        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        Dim dt As DataTable = obj_BookCategorty.SELECT_ALL(-1)
        For i As Integer = 0 To dt.Rows.Count - 1
            Dim BookCategorty_ID_ As Int64 = CLng(dt.Rows(i).Item("BookCategorty_ID"))
            Dim BookCategorty_ID_Parent_ As Int64 = Library_Shared.Functions.GetNumericValue(dt.Rows(i).Item("BookCategorty_ID_Parent"), -1)
            Dim CategoryName_ As String = dt.Rows(i).Item("CategoryName").ToString()

            Dim node_ As New TreeNode
            With node_
                .Name = BookCategorty_ID_
                .Text = CategoryName_
            End With

            AddNodes(node_, BookCategorty_ID_)

            rootNode.Nodes.Add(node_)
        Next i

        TreeView1.Nodes.Add(rootNode)
        TreeView1.SelectedNode = rootNode
        TreeView1.SelectedNode.Expand()
    End Sub

    'این تابع به صورت بازگشتی نوشته شده است و خودش را فراخوانی می کند
    Private Function AddNodes(ByVal n_ As TreeNode, _
                              ByVal ParentID_ As Int64) As TreeNode

        Dim obj_BookCategorty As New Library_Database.Library.BookCategorty
        Dim dt As DataTable = obj_BookCategorty.SELECT_ALL(ParentID_)

        For i As Integer = 0 To dt.Rows.Count - 1
            Dim BookCategorty_ID_ As Int64 = CLng(dt.Rows(i).Item("BookCategorty_ID"))
            Dim BookCategorty_ID_Parent_ As Int64 = Library_Shared.Functions.GetNumericValue(dt.Rows(i).Item("BookCategorty_ID_Parent"), -1)
            Dim CategoryName_ As String = dt.Rows(i).Item("CategoryName").ToString()

            Dim node_ As New TreeNode
            With node_
                .Name = BookCategorty_ID_
                .Text = CategoryName_
            End With

            AddNodes(node_, BookCategorty_ID_)

            n_.Nodes.Add(node_)

        Next i
        Return n_
    End Function

#End Region


End Class